'-------------------------------------------------
'		cga console functions
'		Copyright (c) 2016 Masamichi Kirikae
'-------------------------------------------------
#include once "cga.bi"

namespace cga

'	set cursor state (1:blink 0:hide)
sub set_cursor_state(byval state as s32)
	locate(,,state)
end sub

'	set cursor position (base is 0)
sub set_cursor(byval x as s32, byval y as s32)
	locate(y + 1, x + 1)
end sub

'	get cursor position (base is 0)
sub get_cursor(byref x as s32, byref y as s32)
	x = pos() - 1
	y = csrlin() - 1	
end sub

function format_hms(tms as s32) as string
	dim as s32 h, m, s
	dim as string hs, ms, ss, stime
	h = tms \ 3600
	m = (tms - h * 3600) \ 60
	s = tms mod 60
	hs = str(h)
	select case len(hs)
		case 0
			hs = "00"
		case 1
			hs = "0" + hs
		case else
	end select
	ms = str(m)
	select case len(ms)
		case 0
			ms = "00"
		case 1
			ms = "0" + ms
		case else
	end select
	ss = str(s)
	select case len(ss)
		case 0
			ss = "00"
		case 1
			ss = "0" + ss
		case else
	end select
	stime = hs + ":" + ms + ":" + ss	
	return(stime)	
end function


sub progressbar(byval percent as double)
	dim as s32 fgc, bgc, i, n, cx, cy, x
	dim as u32 c
	dim as string st, s
	static as double start_time, current_time
	dim as double elapsed_time, remain_time
	dim as string remain_time_str

	'	get current color
	c = color()
	fgc = loword(c)
	bgc = hiword(c)
	'	get current cursor position
	get_cursor(cx, cy)

	'	draw dark gray bar
	if (percent = -1) then
		start_time = timer
		set_cursor(0, 24)
		color(CGA_BLACK, CGA_DARK_GRAY)
		print space(80);
		'	restore color
		color(fgc, bgc)
		'	restore cursor position
		set_cursor(cx, cy)
		return
	endif

	'	progress bar
	n = cint(percent * 80 \ 100)
	color(CGA_BLACK, CGA_GRAY)
	set_cursor (0, 24)
	print space(n);
	
	'	display percentage
	st = str(cint(percent)) + "%"
	st = space(4 - len(st)) + st
	for i = 0 to 3
		s = mid(st, i + 1, 1)
		x = 38 + i
		set_cursor(x, 24)
		if (x < n) then
			color(CGA_BLACK, CGA_GRAY)
			print s;
		else
			color(CGA_BLACK, CGA_DARK_GRAY)
			print s;
		end if
	next

	' display remaining time
	if (percent > 0.0) and cga_progressbar_remain_time then
		color(CGA_WHITE, CGA_BLACK)
		current_time = timer
		elapsed_time = (current_time - start_time) * 100 / percent
		remain_time = cint(elapsed_time - (current_time - start_time))
		remain_time_str = format_hms(remain_time)
		set_cursor(0, 23)
		print using "Remaining time &"; remain_time_str;
	endif
	
	'	restore color
	color(fgc, bgc)
	'	restore cursor position
	set_cursor(cx, cy)
end sub

end namespace