'-------------------------------------------------
'		sr2pegtool graphics header file
'		Copyright (c) 2018 Masamichi Kirikae
'-------------------------------------------------

#ifndef false
	#define false	0
	#define true	(not(false))
#endif

#include once "fileio.bi"
#include once "squish.bi"
#include once "datatype.bi"
#include once "ddslib.bi"
#include once "keycode.bi"

#ifndef mouse_data
	type mouse_data
		x as s32
		y as s32
		wheel as s32
		button as s32
		clip as s32
	end type
#endif

#ifndef rgba_data
	type rgba_data
		r as u8
		g as u8
		b as u8
		a as u8
	end type
#endif

#ifndef BACKGROUND_GRID
	#define BACKGROUND_GRID		1
	#define BACKGROUND_WHITE	2
	#define BACKGROUND_BLACK	4
	#define BACKGROUND_END		8
#endif

#ifndef GRAPHICS_WINDOW_CLOSED	
	#define GRAPHICS_WINDOW_CLOSED	chr(255, 107)
#endif

namespace graphics
	
declare function rgba_to_rgb(c as rgba_data) as rgba_data	
declare sub draw_background(xofs as s32, yofs as s32, imagew as u32, imageh as u32, bktype as s32)
declare sub draw_image(title as string, image_rgba() as u8, w as u32, h as u32)
declare sub draw_dds_blocks(title as string, image() as u8, w as u32, h as u32, fmt as s32, mipmap as s32)
declare sub close_window()

end namespace
